version: '3.8'

services:
  zookeeper:
    image: confluentinc/cp-zookeeper:7.4.1
    hostname: zookeeper
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181

  kafka:
    image: confluentinc/cp-kafka:7.4.1
    hostname: kafka
    ports:
      - "29092:29092"
    environment:
      KAFKA_ADVERTISED_LISTENERS: INTERNAL://kafka:9092,EXTERNAL://localhost:29092
      KAFKA_ALLOW_EVERYONE_IF_NO_ACL_FOUND: "true"
      KAFKA_AUTHORIZER_CLASS_NAME: kafka.security.authorizer.AclAuthorizer
      KAFKA_BROKER_ID: 1
      KAFKA_INTER_BROKER_LISTENER_NAME: INTERNAL
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: INTERNAL:PLAINTEXT,EXTERNAL:PLAINTEXT
      KAFKA_LOG4J_LOGGERS: "kafka.controller=INFO,kafka.producer.async.DefaultEventHandler=INFO,state.change.logger=INFO"
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_TRANSACTION_STATE_LOG_MIN_ISR: 1
      KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR: 1
      KAFKA_ZOOKEEPER_CONNECT: "zookeeper:2181"
    depends_on:
      - zookeeper

  kafka-ui:
    image: provectuslabs/kafka-ui:latest
    ports:
      - "8080:8080"
    environment:
      KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS: kafka:9092
      KAFKA_CLUSTERS_0_NAME: local
      KAFKA_CLUSTERS_0_ZOOKEEPER: zookeeper:2181
    depends_on:
      - zookeeper
      - kafka

  minio:
    image: minio/minio
    command: server /data --console-address ":9001"
    restart: unless-stopped
    # volumes:
    #   - ./bucket:/data
    ports:
      - 9000:9000
      - 9001:9001
    environment:
      MINIO_ROOT_USER: 02tzwnQ8qYBRFdn1zzI8XwEXAMPLE
      MINIO_ROOT_PASSWORD: 02tzwnWAIRCBJwA7HtHUnsEXAMPLEKEY

  topicinit:
    build:
      context: ./test/init
    entrypoint: >
      /bin/sh -c "
      wait-for-it kafka:9092;
      kaf config add-cluster local -b kafka:9092;
      kaf config use-cluster local;
      kaf topic create --partitions 1 --replicas 1 applications | true;
      kaf topic create --partitions 1 --replicas 1 payments | true;
      cat /data/application.json | kaf produce applications;
      cat /data/payment.json | kaf produce payments;
      exit 0;
      "
    depends_on:
      - kafka

  createbuckets:
    image: minio/mc
    entrypoint: >
      /bin/sh -c "
      while ! /usr/bin/mc config host add minio http://minio:9000 02tzwnQ8qYBRFdn1zzI8XwEXAMPLE 02tzwnWAIRCBJwA7HtHUnsEXAMPLEKEY;
      do echo 'Wait minio to startup...' && sleep 0.1; done;
      /usr/bin/mc mb --ignore-existing minio/payments;
      /usr/bin/mc mc anonymous set public minio/payments;
      exit 0;
      "
    depends_on:
      - minio

  depag-proxy:
    stop_signal: SIGTERM
    stop_grace_period: 30s
    build:
      context: .
    depends_on:
      - createbuckets
      - kafka
    ports:
      - "8000:8000"
    environment:
      APP_NAME: depag-payment-proxy
      DEBUG: true
      SENTRY_ENABLED: false
      KAFKA_BOOTSTRAP_SERVERS: kafka:9092
      KAFKA_GROUP_ID: depag_payment_proxy
      KAFKA_TOPIC_NAME: payments
      HTTP_BIND: 0.0.0.0
      HTTP_PORT: 8000
      EXTERNAL_API_URL: http://localhost:8000
      INTERNAL_API_URL: http://localhost:9000
      BASEPATH: /
      CACHE_EXPIRATION: 5m
      CACHE_EVICTION: 10m
      STORAGE_TYPE: s3
      STORAGE_BUCKET: payments
      STORAGE_CONFIGS_BASE_PATH: sdc-payments/depag/tenants/
      STORAGE_EVENTS_BASE_PATH: sdc-payments/depag/payments/
      STORAGE_S3_KEY: 02tzwnQ8qYBRFdn1zzI8XwEXAMPLE
      STORAGE_S3_SECRET: 02tzwnWAIRCBJwA7HtHUnsEXAMPLEKEY
      STORAGE_S3_REGION: local
      STORAGE_S3_ENDPOINT: minio:9000
      STORAGE_S3_SSL: false
      DEPAG_WEBHOOK_USER: opencontent
      DEPAG_WEBHOOK_PASS: test_opencontent
    healthcheck:
      test: ["CMD", "curl", "-f", "http://localhost:8000/status"]
      interval: 30s
      timeout: 5s
      retries: 3
      start_period: 5s
